Index: /data/media/levels/presentation_level1_felix.oxw
===================================================================
--- /data/media/levels/presentation_level1_felix.oxw	(revision 5384)
+++ /data/media/levels/presentation_level1_felix.oxw	(revision 5385)
@@ -11,5 +11,5 @@
 	<Scene
 		ambientlight = "0.8, 0.8, 0.8"
-		skybox = "Orxonox/skypanoramagen1"
+		skybox = "Orxonox/skypanoramagen1"	
 	>
 
@@ -58,4 +58,61 @@
 	<Planet position="1500,0,-5000" scale=1000 pitch=-90 mesh="iceplanet.mesh" atmosphere="atmosphere1" rotationaxis="1,1,0" rotationrate="1" atmospheresize=224.0f imagesize=1024.0f />
     
+<!-------------------------------------------------------------------->
+	<!--UEA Transporter T036-03-->
+    <MovableEntity position="-500,-300,-800" velocity="60,0,0" rotationaxis="1,-1,-1" rotationrate=0>
+      <attached>
+		<Model position="0,0,0" scale=20 roll=0 pitch=-90 yaw=0 mesh="UEATransporter036.mesh" />
+		
+		<!--Engine Front Right-->
+		<MovableEntity position="120,14,70" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+			<attached>
+				<Model position="0,0,0" scale=20 roll=-90 pitch=-90 	yaw=90 mesh="UEATransporter036T.mesh" />
+					<MovableEntity position="0,0,35" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+						<attached>
+							<ParticleEmitter pitch=0 roll=180 position="0,0,0" source="Orxonox/smoke5" lifetime=2.0 loop=1 startdelay=3.0 />
+						</attached>
+					</MovableEntity>
+			</attached>
+		</MovableEntity>
+		
+		<!--Engine Front Left-->
+		<MovableEntity position="120,14,-70" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+			<attached>
+				<Model position="0,0,0" scale=20 roll=90 	pitch=-90 	yaw=90 mesh="UEATransporter036T.mesh" />
+					<MovableEntity position="0,-60,-35" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+						<attached>
+        					<!--ParticleEmitter pitch=0 roll=180 position="0,0,0" source="Orxonox/engineglow" lifetime=2.0 loop=1 startdelay=3.0 /-->
+						</attached>
+					</MovableEntity>
+			</attached>
+		</MovableEntity>
+
+		<!--Engine Back Right-->
+		<MovableEntity position="-90,30,70" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+			<attached>
+				<Model position="0,0,0" scale=20 roll=-90 	pitch=0 	yaw=90 mesh="UEATransporter036T.mesh" />
+					<MovableEntity position="-60,0,35" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+						<attached>
+        					<ParticleEmitter pitch=0 roll=180 position="0,0,0" source="Orxonox/engineglow" lifetime=2.0 loop=1 startdelay=3.0 />
+						</attached>
+					</MovableEntity>
+			</attached>
+		</MovableEntity>
+
+		<!--Engine Back Left-->
+		<MovableEntity position="-90,30,-70" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+			<attached>
+				<Model position="0,0,0" scale=20 roll=90 	pitch=0 	yaw=90 mesh="UEATransporter036T.mesh" />
+					<MovableEntity position="-60,0,-35" velocity="0,0,0" rotationaxis="1,0,0" rotationrate=0>
+						<attached>
+        					<ParticleEmitter pitch=0 roll=180 position="0,0,0" source="Orxonox/engineglow" lifetime=2.0 loop=1 startdelay=3.0 />
+						</attached>
+					</MovableEntity>
+			</attached>
+		</MovableEntity>
+      </attached>
+    </MovableEntity>
+	<!--T036-03 End-->
+<!----------------------------------------------->
 
 	<ParticleSpawner position="0,0,0" source="Orxonox/BigExplosion1part3" lifetime=2.0 loop=0 autostart=0>
Index: /data/media/levels/sample2.oxw
===================================================================
--- /data/media/levels/sample2.oxw	(revision 5384)
+++ /data/media/levels/sample2.oxw	(revision 5385)
@@ -52,5 +52,5 @@
         <MovableEntity position="-4,0,0" velocity="0,0,0" rotationaxis="0,0,1" rotationrate=50>
 	  <attached>
-            <Model position="4,0,0" scale=10 mesh="satellitedish.mesh"/>
+            <Model position="4,0,0" scale=10 mesh="badsatellitedish.mesh"/>
           </attached>
 	</MovableEntity>
Index: /data/media/materials/scripts/UEATransporter036.material
===================================================================
--- /data/media/materials/scripts/UEATransporter036.material	(revision 5385)
+++ /data/media/materials/scripts/UEATransporter036.material	(revision 5385)
@@ -0,0 +1,50 @@
+material UEATransporter036/TEXFACE/SpaceShipTransporter036_newtexture.jpg
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.500000 0.500000 0.500000 1.000000
+			diffuse 0.800000 0.800000 0.800000 1.000000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture SpaceShipTransporter036_newtexture.jpg
+				colour_op modulate
+			}
+		}
+		pass
+		{
+			ambient 0.0 0.0 0.0
+			diffuse 0.0 0.0 0.0
+			specular 0.500000 0.500000 0.500000 1.000000 12.500000
+			scene_blend add
+		}
+	}
+}
+material UEATransporter036T/TEXFACE/SpaceShipTransporter036_engine.jpg
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.500000 0.500000 0.500000 1.000000
+			diffuse 0.800000 0.800000 0.800000 1.000000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture SpaceShipTransporter036_engine.jpg
+				colour_op modulate
+			}
+		}
+		pass
+		{
+			ambient 0.0 0.0 0.0
+			diffuse 0.0 0.0 0.0
+			specular 0.500000 0.500000 0.500000 1.000000 12.500000
+			scene_blend add
+		}
+	}
+}