Index: trunk/src/lib/graphics/importer/model.cc
===================================================================
--- trunk/src/lib/graphics/importer/model.cc	(revision 5389)
+++ trunk/src/lib/graphics/importer/model.cc	(revision 5390)
@@ -162,7 +162,7 @@
   this->scaleFactor = 1;
 
-  this->vertices = new Array<GLfloat>();
-  this->vTexture = new Array<GLfloat>();
-  this->normals = new Array<GLfloat>();
+  this->vertices = new tArray<GLfloat>();
+  this->vTexture = new tArray<GLfloat>();
+  this->normals = new tArray<GLfloat>();
 
   this->materialList = new tList<ModelMaterial>;
Index: trunk/src/lib/graphics/importer/model.h
===================================================================
--- trunk/src/lib/graphics/importer/model.h	(revision 5389)
+++ trunk/src/lib/graphics/importer/model.h	(revision 5390)
@@ -15,5 +15,5 @@
 
 // FORWARD DEFINITION //
-template<class T> class Array;
+template<class T> class tArray;
 template<class T> class tList;
 
@@ -184,7 +184,7 @@
   unsigned int           faceCount;       //!< A modelwide Counter for the faces
   unsigned int           triangleCount;   //!< Number of triangles >= faceCount
-  Array<GLfloat>*        vertices;        //!< The Array that handles the Vertices.
-  Array<GLfloat>*        normals;         //!< The Array that handles the Normals.
-  Array<GLfloat>*        vTexture;        //!< The Array that handles the VertexTextureCoordinates.
+  tArray<GLfloat>*       vertices;        //!< The Array that handles the Vertices.
+  tArray<GLfloat>*       normals;         //!< The Array that handles the Normals.
+  tArray<GLfloat>*       vTexture;        //!< The Array that handles the VertexTextureCoordinates.
   sTriangleExt*          triangles;       //!< The Array of triangles in the abstract_model.h style
 
Index: trunk/src/lib/graphics/shader.cc
===================================================================
--- trunk/src/lib/graphics/shader.cc	(revision 5389)
+++ trunk/src/lib/graphics/shader.cc	(revision 5390)
@@ -126,5 +126,5 @@
 
 
-  Array<char*>* program = fileReadArray(fileName);
+  tArray<char*>* program = fileReadArray(fileName);
   if (program == NULL)
     return false;
@@ -190,5 +190,5 @@
 
 
-Array<char*>* Shader::fileReadArray(const char* fileName)
+tArray<char*>* Shader::fileReadArray(const char* fileName)
 {
   FILE*    stream;           //< The stream we use to read the file.
@@ -199,5 +199,5 @@
     return NULL;
   }
-  Array<char*>* file = new Array<char*>;
+  tArray<char*>* file = new tArray<char*>;
 
   char lineBuffer[PARSELINELENGHT];
Index: trunk/src/lib/graphics/shader.h
===================================================================
--- trunk/src/lib/graphics/shader.h	(revision 5389)
+++ trunk/src/lib/graphics/shader.h	(revision 5390)
@@ -10,5 +10,5 @@
 #include "glincl.h"
 
-template<class T> class Array;
+template<class T> class tArray;
 
 typedef enum
@@ -38,5 +38,5 @@
 
   char* fileRead(const char* fileName);
-  Array<char*>* fileReadArray(const char* fileName);
+  tArray<char*>* fileReadArray(const char* fileName);
 
   static bool checkShaderAbility();
Index: trunk/src/lib/util/array.h
===================================================================
--- trunk/src/lib/util/array.h	(revision 5389)
+++ trunk/src/lib/util/array.h	(revision 5390)
@@ -16,5 +16,5 @@
 /*!
   @file array.h
-  @brief Contains the Array Class that handles arrays of classes.
+  @brief Contains the tArray Class that handles arrays of classes.
   this class creates a Array of a semi-Dynamic length.
   beware, that after finalizing the array may not be resized again.
@@ -27,10 +27,10 @@
 using namespace std;
 
-//! Array Class that handles dynamic-type arrays.
-template<class T> class Array
+//! tArray Class that handles dynamic-type arrays.
+template<class T> class tArray
 {
   public:
-    Array ();
-    ~Array();
+    tArray ();
+    ~tArray();
 
     void finalizeArray ();
@@ -67,7 +67,7 @@
 */
 template<class T>
-Array<T>::Array ()
-{
-  PRINTF(5)("crating new Array\n");
+tArray<T>::tArray ()
+{
+  PRINTF(5)("crating new tArray\n");
   this->firstEntry = new Entry;
   this->firstEntry->next =NULL;
@@ -78,5 +78,5 @@
 
 template<class T>
-    const T Array<T>::getEntry(unsigned int number) const
+    const T tArray<T>::getEntry(unsigned int number) const
 {
   if (this->finalized && number < this->entryCount)
@@ -89,5 +89,5 @@
 */
 template<class T>
-Array<T>::~Array()
+tArray<T>::~tArray()
 {
   PRINTF(5)("deleting array\n");
@@ -112,5 +112,5 @@
 */
 template<class T>
-void Array<T>::finalizeArray ()
+void tArray<T>::finalizeArray ()
 {
   if (this->finalized)
@@ -142,5 +142,5 @@
 */
 template<class T>
-void Array<T>::addEntry (T entry)
+void tArray<T>::addEntry (T entry)
 {
   if (!this->finalized)
@@ -162,5 +162,5 @@
 */
 template<class T>
-void Array<T>::addEntry (T entry0, T entry1, T entry2)
+void tArray<T>::addEntry (T entry0, T entry1, T entry2)
 {
   this->addEntry(entry0);
@@ -176,5 +176,5 @@
  */
 template<class T>
-int Array<T>::getIndex(T* entry) const
+int tArray<T>::getIndex(T* entry) const
 {
   if( unlikely(this->finalized == false))
@@ -193,5 +193,5 @@
 */
 template<class T>
-void Array<T>::debug () const
+void tArray<T>::debug () const
 {
   PRINT(0)("entryCount=%i, address=%p\n", this->entryCount, this->array);